The Spring Framework

## org.springframework.jndi.support
Class SimpleJndiBeanFactory

    java.lang.Object
      org.springframework.jndi.JndiAccessor
          org.springframework.jndi.JndiLocatorSupport
              org.springframework.jndi.support.SimpleJndiBeanFactory

All Implemented Interfaces:
  BeanFactory

    public class SimpleJndiBeanFactory

extends JndiLocatorSupport
implements BeanFactory

Simple JNDI-based implementation of Spring's `BeanFactory` interface. Does not support enumerating bean definitions, hence doesn't implement the `ListableBeanFactory` interface.

This factory resolves given bean names as JNDI names within the J2EE application's "java:comp/env/" namespace. It caches the resolved types for all obtained objects, and optionally also caches shareable objects (if they are explicitly marked as `shareable resource`.

The main intent of this factory is usage in combination with Spring's `CommonAnnotationBeanPostProcessor`, configured as "resourceFactory" for resolving `@Resource` annotations as JNDI objects without intermediate bean definitions. It may be used for similar lookup scenarios as well, of course, in particular if BeanFactory-style type checking is required.

Since:
  2.5
Author:
  Juergen Hoeller
See Also:
  `DefaultListableBeanFactory`, `CommonAnnotationBeanPostProcessor`

Field Summary

Fields inherited from class org.springframework.jndi.JndiLocatorSupport
`CONTAINER_PREFIX`

Fields inherited from class org.springframework.jndi.JndiAccessor
`logger`

Fields inherited from interface org.springframework.beans.factory.BeanFactory
`FACTORY_BEAN_PREFIX`

Constructor Summary
`SimpleJndiBeanFactory()`

Method Summary
`void` `addShareableResource(String shareableResource)` Add the name of a shareable JNDI resource, which this factory is allowed to cache once obtained.
`boolean` `containsBean(String name)` Does this bean factory contain a bean with the given name?
`String[]` `getAliases(String name)` Return the aliases for the given bean name, if any.
`Object` `getBean(String name)` Return an instance, which may be shared or independent, of the specified bean.
`Object` `getBean(String name, Class requiredType)` Return an instance, which may be shared or independent, of the specified bean.
`Object` `getBean(String name, Object[] args)` Return an instance, which may be shared or independent, of the specified bean.
`Class` `getType(String name)` Determine the type of the bean with the given name.
`boolean` `isPrototype(String name)` Is this bean a prototype?
`boolean` `isSingleton(String name)` Is this bean a shared singleton?
`boolean` `isTypeMatch(String name, Class targetType)` Check whether the bean with the given name matches the specified type.
`void` `setShareableResources(String[] shareableResources)` Set a list of names of shareable JNDI resources, which this factory is allowed to cache once obtained.

Methods inherited from class org.springframework.jndi.JndiLocatorSupport
`convertJndiName, isResourceRef, lookup, lookup, setResourceRef`

Methods inherited from class org.springframework.jndi.JndiAccessor
`getJndiEnvironment, getJndiTemplate, setJndiEnvironment, setJndiTemplate`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### SimpleJndiBeanFactory

    public SimpleJndiBeanFactory()

Method Detail

### setShareableResources

    public void setShareableResources(String[] shareableResources)

  Set a list of names of shareable JNDI resources, which this factory is allowed to cache once obtained.

  Parameters:
    `shareableResources` - the JNDI names (typically within the "java:comp/env/" namespace)

### addShareableResource

    public void addShareableResource(String shareableResource)

  Add the name of a shareable JNDI resource, which this factory is allowed to cache once obtained.

  Parameters:
    `shareableResource` - the JNDI name (typically within the "java:comp/env/" namespace)

### getBean

    public Object getBean(String name)
                   throws BeansException

  Description copied from interface: `BeanFactory`
  Return an instance, which may be shared or independent, of the specified bean.

  This method allows a Spring BeanFactory to be used as a replacement for the Singleton or Prototype design pattern. Callers may retain references to returned objects in the case of Singleton beans.

  Translates aliases back to the corresponding canonical bean name. Will ask the parent factory if the bean cannot be found in this factory instance.

  Specified by:
    `getBean` in interface `BeanFactory`
  Parameters:
    `name` - the name of the bean to retrieve
  Returns:
    an instance of the bean
  Throws:
    `NoSuchBeanDefinitionException` - if there is no bean definition with the specified name
    `BeansException` - if the bean could not be obtained

### getBean

    public Object getBean(String name,
                          Class requiredType)
                   throws BeansException

  Description copied from interface: `BeanFactory`
  Return an instance, which may be shared or independent, of the specified bean.

  Behaves the same as `BeanFactory.getBean(String)`, but provides a measure of type safety by throwing a BeanNotOfRequiredTypeException if the bean is not of the required type. This means that ClassCastException can't be thrown on casting the result correctly, as can happen with `BeanFactory.getBean(String)`.

  Translates aliases back to the corresponding canonical bean name. Will ask the parent factory if the bean cannot be found in this factory instance.

  Specified by:
    `getBean` in interface `BeanFactory`
  Parameters:
    `name` - the name of the bean to retrieve
    `requiredType` - type the bean must match. Can be an interface or superclass of the actual class, or `null` for any match. For example, if the value is `Object.class`, this method will succeed whatever the class of the returned instance.
  Returns:
    an instance of the bean
  Throws:
    `NoSuchBeanDefinitionException` - if there's no such bean definition
    `BeanNotOfRequiredTypeException` - if the bean is not of the required type
    `BeansException` - if the bean could not be created

### getBean

    public Object getBean(String name,
                          Object[] args)
                   throws BeansException

  Description copied from interface: `BeanFactory`
  Return an instance, which may be shared or independent, of the specified bean.

  Allows for specifying explicit constructor arguments / factory method arguments, overriding the specified default arguments (if any) in the bean definition.

  Specified by:
    `getBean` in interface `BeanFactory`
  Parameters:
    `name` - the name of the bean to retrieve
    `args` - arguments to use if creating a prototype using explicit arguments to a static factory method. It is invalid to use a non-null args value in any other case.
  Returns:
    an instance of the bean
  Throws:
    `NoSuchBeanDefinitionException` - if there's no such bean definition
    `BeanDefinitionStoreException` - if arguments have been given but the affected bean isn't a prototype
    `BeansException` - if the bean could not be created

### containsBean

    public boolean containsBean(String name)

  Description copied from interface: `BeanFactory`
  Does this bean factory contain a bean with the given name? More specifically, is `BeanFactory.getBean(java.lang.String)` able to obtain a bean instance for the given name?

  Translates aliases back to the corresponding canonical bean name. Will ask the parent factory if the bean cannot be found in this factory instance.

  Specified by:
    `containsBean` in interface `BeanFactory`
  Parameters:
    `name` - the name of the bean to query
  Returns:
    whether a bean with the given name is defined

### isSingleton

    public boolean isSingleton(String name)
                        throws NoSuchBeanDefinitionException

  Description copied from interface: `BeanFactory`
  Is this bean a shared singleton? That is, will `BeanFactory.getBean(java.lang.String)` always return the same instance?

  Note: This method returning `false` does not clearly indicate independent instances. It indicates non-singleton instances, which may correspond to a scoped bean as well. Use the `BeanFactory.isPrototype(java.lang.String)` operation to explicitly check for independent instances.

  Translates aliases back to the corresponding canonical bean name. Will ask the parent factory if the bean cannot be found in this factory instance.

  Specified by:
    `isSingleton` in interface `BeanFactory`
  Parameters:
    `name` - the name of the bean to query
  Returns:
    whether this bean corresponds to a singleton instance
  Throws:
    `NoSuchBeanDefinitionException` - if there is no bean with the given name
  See Also:
    `BeanFactory.getBean(java.lang.String)`, `BeanFactory.isPrototype(java.lang.String)`

### isPrototype

    public boolean isPrototype(String name)
                        throws NoSuchBeanDefinitionException

  Description copied from interface: `BeanFactory`
  Is this bean a prototype? That is, will `BeanFactory.getBean(java.lang.String)` always return independent instances?

  Note: This method returning `false` does not clearly indicate a singleton object. It indicates non-independent instances, which may correspond to a scoped bean as well. Use the `BeanFactory.isSingleton(java.lang.String)` operation to explicitly check for a shared singleton instance.

  Translates aliases back to the corresponding canonical bean name. Will ask the parent factory if the bean cannot be found in this factory instance.

  Specified by:
    `isPrototype` in interface `BeanFactory`
  Parameters:
    `name` - the name of the bean to query
  Returns:
    whether this bean will always deliver independent instances
  Throws:
    `NoSuchBeanDefinitionException` - if there is no bean with the given name
  See Also:
    `BeanFactory.getBean(java.lang.String)`, `BeanFactory.isSingleton(java.lang.String)`

### isTypeMatch

    public boolean isTypeMatch(String name,
                               Class targetType)
                        throws NoSuchBeanDefinitionException

  Description copied from interface: `BeanFactory`
  Check whether the bean with the given name matches the specified type. More specifically, check whether a `BeanFactory.getBean(java.lang.String)` call for the given name would return an object that is assignable to the specified target type.

  Translates aliases back to the corresponding canonical bean name. Will ask the parent factory if the bean cannot be found in this factory instance.

  Specified by:
    `isTypeMatch` in interface `BeanFactory`
  Parameters:
    `name` - the name of the bean to query
    `targetType` - the type to match against
  Returns:
    `true` if the bean type matches, `false` if it doesn't match or cannot be determined yet
  Throws:
    `NoSuchBeanDefinitionException` - if there is no bean with the given name
  See Also:
    `BeanFactory.getBean(java.lang.String)`, `BeanFactory.getType(java.lang.String)`

### getType

    public Class getType(String name)
                  throws NoSuchBeanDefinitionException

  Description copied from interface: `BeanFactory`
  Determine the type of the bean with the given name. More specifically, determine the type of object that `BeanFactory.getBean(java.lang.String)` would return for the given name.

  For a `FactoryBean`, return the type of object that the FactoryBean creates, as exposed by `FactoryBean.getObjectType()`.

  Translates aliases back to the corresponding canonical bean name. Will ask the parent factory if the bean cannot be found in this factory instance.

  Specified by:
    `getType` in interface `BeanFactory`
  Parameters:
    `name` - the name of the bean to query
  Returns:
    the type of the bean, or `null` if not determinable
  Throws:
    `NoSuchBeanDefinitionException` - if there is no bean with the given name
  See Also:
    `BeanFactory.getBean(java.lang.String)`, `BeanFactory.isTypeMatch(java.lang.String, java.lang.Class)`

### getAliases

    public String[] getAliases(String name)

  Description copied from interface: `BeanFactory`
  Return the aliases for the given bean name, if any. All of those aliases point to the same bean when used in a `BeanFactory.getBean(java.lang.String)` call.

  If the given name is an alias, the corresponding original bean name and other aliases (if any) will be returned, with the original bean name being the first element in the array.

  Will ask the parent factory if the bean cannot be found in this factory instance.

  Specified by:
    `getAliases` in interface `BeanFactory`
  Parameters:
    `name` - the bean name to check for aliases
  Returns:
    the aliases, or an empty array if none
  See Also:
    `BeanFactory.getBean(java.lang.String)`

The Spring Framework

Copyright © 2002-2008 The Spring Framework.